this.author      = "Zireael"; 
this.copyright   = "� 2013 Zireael."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "0.4"; 
this.name = "Engine Trails";

this.$trailed_Ships = [ player.ship ];
this.$trail_number = [];
this.$TrailsTimer = null
this.$RemoveTrailsTimer = null

this.startUp = function() {
		this.$addDelay = 0.5;
		this.$decayPower = 0.20;
		this.$TrailsTimer = new Timer(this, this.$TrailsTimed, 2, 2);
		this.$RemoveTrailsTimer = new Timer(this, this.$removeFlares, 30, 30);
}

this.shipWillLaunchFromStation = this.shipWillExitWitchspace = function() {
		this.$flares = new Array();
		this.$spawnFlares();
//		this.$accumulator = 0;
//		this.$process = addFrameCallback(this._updateFlares.bind(this));
}

this.shipWillDockWithStation = this.shipWillEnterWitchspace = function() {
//		removeFrameCallback(this.$process);
		for (var i=0;i<this.$flares.length;i++) {
				this.$flares[i].remove();
		}
		this.$flares = new Array();
		this.$trailed_Ships = [ player.ship ];
}

this.shipSpawned = function(ship)	{
	if( !ship.isPlayer && this.$trailed_Ships.indexOf(ship) < 0) {//only new NPC ships
		this.$trailed_Ships[this.$trailed_Ships.length] = ship;
		this.$flares = new Array();
	}
}


/*	if( !ship.isPiloted || ship.isStation || ship.isThargoid || ship.primaryRole === "escape-capsule" ) return;
//	var distance = player.ship.position.distanceTo( ship.position );
//	if( !ship.isPlayer && ship.speed > 0.5 && distance < player.ship.scannerRange)
//	{
//		var vtype = "engineflare_normal";
//		var vpos1 = ship.position.add(ship.vectorForward.multiply(-60)).add(ship.vectorUp.multiply(6.3)).add(ship.vectorRight.multiply(10.76));
//		var vpos2 = ship.position.add(ship.vectorForward.multiply(-60)).add(ship.vectorUp.multiply(6.3)).add(ship.vectorRight.multiply(-10.76));
						
//		this.$flares.push(system.addVisualEffect(vtype,vpos1));
//		this.$flares.push(system.addVisualEffect(vtype,vpos2));


//		this.$setFlares();
		this.CheckDistanceTimer = new Timer(ship, this.$checkPlayerDistance, 2, 2); */


this.$TrailsTimed = function(){
	if( player.ship.docked ) return; //nothing happens if player's docked

	for( var i = 0; i < this.$trailed_Ships.length; i++)
		{
		var ship = this.$trailed_Ships[i];
		
		if( ship && ship.isValid && ship.isVisible && ship.isPiloted
			&& !ship.isThargoid  && !ship.isDerelict 
			&& !ship.isPlayer && ship.speed > 0.5)
			{
			var distance = player.ship.position.distanceTo( ship.position );
			if (distance < 10000) //further than that the trails are too small to be seen 
			{	
		this.$flares = new Array();
		if (this.$trail_number = 1) { var vtype = "engine_trail_blue" }
		if (this.$trail_number = 2) { var vtype = "engine_trail_yellow" }
		if (this.$trail_number = 3) { var vtype = "engine_trail_3" }

		var vpos1 = ship.position.add(ship.vectorForward.multiply(-60)).add(ship.vectorUp.multiply(6.3)).add(ship.vectorRight.multiply(10.76));
		var vpos2 = ship.position.add(ship.vectorForward.multiply(-60)).add(ship.vectorUp.multiply(6.3)).add(ship.vectorRight.multiply(-10.76));
						
		this.$flares.push(system.addVisualEffect(vtype,vpos1));
		this.$flares.push(system.addVisualEffect(vtype,vpos2));

		if (this.$trail_number < 0) //not in range 
			{ 
			this.$trail_number = this.$trail_number + 1;
		}  		
}
		if (this.$trail_number > 0 && distance > 10000) //already been in range
		{
			this.$trail_number = this.$trail_number - 1;
		}
}
}
}

this.$setFlares = function ()
{
	this.$flares = new Array();
}

this.$spawnFlares = function() 
{
this.$flares = new Array();

if (player.ship && player.ship.speed > 0)
{
	var vtype = "engine_trail_3";
	var vpos1 = player.ship.position.add(player.ship.vectorForward.multiply(-60)).add(player.ship.vectorUp.multiply(6.3)).add(player.ship.vectorRight.multiply(10.76));
	var vpos2 = player.ship.position.add(player.ship.vectorForward.multiply(-60)).add(player.ship.vectorUp.multiply(6.3)).add(player.ship.vectorRight.multiply(-10.76));
						
	this.$flares.push(system.addVisualEffect(vtype,vpos1));
	this.$flares.push(system.addVisualEffect(vtype,vpos2));
}
}

this.$removeFlares = function(){
	for (var i=0;i<this.$flares.length;i++) {
				this.$flares[i].remove();
		}
		this.$flares = new Array();
}